# ChunkCodecLibBzip2

## Warning: ChunkCodecLibBzip2 is currently a WIP and its API may drastically change at any time.

This package implements the ChunkCodec interface for the following encoders and decoders
using the bzip2 C library <https://sourceware.org/bzip2/>

1. `BZ2Codec`, `BZ2EncodeOptions`, `BZ2DecodeOptions`

## Example

```julia-repl
julia> using ChunkCodecLibBzip2

julia> data = [0x00, 0x01, 0x02, 0x03];

julia> compressed_data = encode(BZ2EncodeOptions(), data);

julia> decompressed_data = decode(BZ2Codec(), compressed_data; max_size=length(data), size_hint=length(data));

julia> data == decompressed_data
true
```

The low level interface is defined in the `ChunkCodecCore` package.

# Constants and c wrapper functions ported to Julia from bzlib.h bzip2/libbzip2 version 1.0.8 of 13 July 2019

# This is needed because the header file uses the WINAPI macro when compiled for WIN32.
# This means the stdcall calling convention needs to be used on WIN32.
const WIN32 = Sys.iswindows() && Sys.WORD_SIZE == 32

const BZ_RUN              = Cint(0)
const BZ_FLUSH            = Cint(1)
const BZ_FINISH           = Cint(2)

const BZ_OK               = Cint(0)
const BZ_RUN_OK           = Cint(1)
const BZ_FLUSH_OK         = Cint(2)
const BZ_FINISH_OK        = Cint(3)
const BZ_STREAM_END       = Cint(4)
const BZ_SEQUENCE_ERROR   = Cint(-1)
const BZ_PARAM_ERROR      = Cint(-2)
const BZ_MEM_ERROR        = Cint(-3)
const BZ_DATA_ERROR       = Cint(-4)
const BZ_DATA_ERROR_MAGIC = Cint(-5)
const BZ_IO_ERROR         = Cint(-6)
const BZ_UNEXPECTED_EOF   = Cint(-7)
const BZ_OUTBUFF_FULL     = Cint(-8)
const BZ_CONFIG_ERROR     = Cint(-9)

@assert typemax(Csize_t) ≥ typemax(Cint)

function bzalloc(::Ptr{Cvoid}, m::Cint, n::Cint)::Ptr{Cvoid}
    s, f = Base.Checked.mul_with_overflow(m, n)
    if f || signbit(s)
        C_NULL
    else
        ccall(:jl_malloc, Ptr{Cvoid}, (Csize_t,), s%Csize_t)
    end
end
bzfree(::Ptr{Cvoid}, p::Ptr{Cvoid}) = ccall(:jl_free, Cvoid, (Ptr{Cvoid},), p)

mutable struct BZStream
    next_in::Ptr{Cchar}
    avail_in::Cuint
    total_in_lo32::Cuint
    total_in_hi32::Cuint

    next_out::Ptr{Cchar}
    avail_out::Cuint
    total_out_lo32::Cuint
    total_out_hi32::Cuint

    state::Ptr{Cvoid}

    bzalloc::Ptr{Cvoid}
    bzfree::Ptr{Cvoid}
    opaque::Ptr{Cvoid}

    function BZStream()
        new(
            C_NULL, 0, 0, 0,
            C_NULL, 0, 0, 0,
            C_NULL,
            @cfunction(bzalloc, Ptr{Cvoid}, (Ptr{Cvoid}, Cint, Cint)),
            @cfunction(bzfree, Cvoid, (Ptr{Cvoid}, Ptr{Cvoid})),
            C_NULL,
        )
    end
end

function BZ2_bzCompressInit(stream::BZStream, blockSize100k::Cint)
    @static if WIN32
        ret = ccall(
            ("BZ2_bzCompressInit@16", libbzip2),
            stdcall,
            Cint,
            (Ref{BZStream}, Cint, Cint, Cint),
            stream, blockSize100k, 0, 0,
        )
    else
        ret = ccall(
            (:BZ2_bzCompressInit, libbzip2),
            Cint,
            (Ref{BZStream}, Cint, Cint, Cint),
            stream, blockSize100k, 0, 0,
        )
    end
    # error out if init failed
    if ret != BZ_OK
        if ret == BZ_CONFIG_ERROR
            error("BZ_CONFIG_ERROR the library has been mis-compiled")
        elseif ret == BZ_PARAM_ERROR
            error("BZ_PARAM_ERROR this should be unreachable")
        elseif ret == BZ_MEM_ERROR
            throw(OutOfMemoryError())
        else
            error("Unknown bzip2 error code: $(ret)")
        end
    end
    nothing
end

function BZ2_bzCompress(stream::BZStream, action::Cint)::Cint
    @static if WIN32
        ccall(
            ("BZ2_bzCompress@8", libbzip2),
            stdcall,
            Cint,
            (Ref{BZStream}, Cint),
            stream, action,
        )
    else
        ccall(
            (:BZ2_bzCompress, libbzip2),
            Cint,
            (Ref{BZStream}, Cint),
            stream, action,
        )
    end
end

function BZ2_bzCompressEnd(stream::BZStream)
    # free bzip2 stream state, not much to do if this fails
    if stream.state != C_NULL
        @static if WIN32
            ccall(
                ("BZ2_bzCompressEnd@4", libbzip2),
                stdcall,
                Cint,
                (Ref{BZStream},),
                stream,
            )
        else
            ccall(
                (:BZ2_bzCompressEnd, libbzip2),
                Cint,
                (Ref{BZStream},),
                stream,
            )
        end
    end
    nothing
end

function BZ2_bzDecompressInit(stream::BZStream)
    @static if WIN32
        ret = ccall(
            ("BZ2_bzDecompressInit@12", libbzip2),
            stdcall,
            Cint,
            (Ref{BZStream}, Cint, Cint),
            stream, 0, 0,
        )
    else
        ret = ccall(
            (:BZ2_bzDecompressInit, libbzip2),
            Cint,
            (Ref{BZStream}, Cint, Cint),
            stream, 0, 0,
        )
    end
    # error out if init failed
    if ret != BZ_OK
        if ret == BZ_CONFIG_ERROR
            error("BZ_CONFIG_ERROR the library has been mis-compiled")
        elseif ret == BZ_PARAM_ERROR
            error("BZ_PARAM_ERROR this should be unreachable")
        elseif ret == BZ_MEM_ERROR
            throw(OutOfMemoryError())
        else
            error("unknown bzip2 error code: $(ret)")
        end
    end
    nothing
end

function BZ2_bzDecompress(stream::BZStream)::Cint
    @static if WIN32
        ccall(
            ("BZ2_bzDecompress@4", libbzip2),
            stdcall,
            Cint,
            (Ref{BZStream},),
            stream,
        )
    else
        ccall(
            (:BZ2_bzDecompress, libbzip2),
            Cint,
            (Ref{BZStream},),
            stream,
        )
    end
end

function BZ2_bzDecompressEnd(stream::BZStream)
    # free bzip2 stream state, not much to do if this fails
    if stream.state != C_NULL
        @static if WIN32
            ccall(
                ("BZ2_bzDecompressEnd@4", libbzip2),
                stdcall,
                Cint,
                (Ref{BZStream},),
                stream,
            )
        else
            ccall(
                (:BZ2_bzDecompressEnd, libbzip2),
                Cint,
                (Ref{BZStream},),
                stream,
            )
        end
    end
    nothing
end


# The following is the original license info from bzlib.h and LICENSE

#=
/*-------------------------------------------------------------*/
/*--- Public header file for the library.                   ---*/
/*---                                               bzlib.h ---*/
/*-------------------------------------------------------------*/

/* ------------------------------------------------------------------
   This file is part of bzip2/libbzip2, a program and library for
   lossless, block-sorting data compression.

   bzip2/libbzip2 version 1.0.8 of 13 July 2019
   Copyright (C) 1996-2019 Julian Seward <jseward@acm.org>

   Please read the WARNING, DISCLAIMER and PATENTS sections in the 
   README file.

   This program is released under the terms of the license contained
   in the file LICENSE.
   ------------------------------------------------------------------ */
=#

#= contents of LICENSE
This program, "bzip2", the associated library "libbzip2", and all
documentation, are copyright (C) 1996-2019 Julian R Seward.  All
rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

2. The origin of this software must not be misrepresented; you must 
   not claim that you wrote the original software.  If you use this 
   software in a product, an acknowledgment in the product 
   documentation would be appreciated but is not required.

3. Altered source versions must be plainly marked as such, and must
   not be misrepresented as being the original software.

4. The name of the author may not be used to endorse or promote 
   products derived from this software without specific prior written 
   permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Julian Seward, jseward@acm.org
bzip2/libbzip2 version 1.0.8 of 13 July 2019
=#

"""
    BZ2DecodingError(code)

Error for data that cannot be decoded.
"""
struct BZ2DecodingError <: DecodingError
    code::Cint
end

function Base.showerror(io::IO, err::BZ2DecodingError)
    print(io, "BZ2DecodingError: ")
    if err.code == BZ_DATA_ERROR
        print(io, "BZ_DATA_ERROR: a data integrity error is detected in the compressed stream")
    elseif err.code == BZ_DATA_ERROR_MAGIC
        print(io, "BZ_DATA_ERROR_MAGIC: the compressed stream doesn't begin with the right magic bytes")
    elseif err.code == BZ_UNEXPECTED_EOF
        print(io, "BZ_UNEXPECTED_EOF: the compressed stream may be truncated")
    else
        print(io, "unknown bzip2 error code: ")
        print(io, err.code)
    end
    nothing
end

"""
    struct BZ2DecodeOptions <: DecodeOptions
    BZ2DecodeOptions(; kwargs...)

bzip2 decompression using libbzip2: https://sourceware.org/bzip2/

Like the command line tool `bunzip2`, decoding accepts concatenated compressed data and returns the decompressed data concatenated.
Unlike `bunzip2`, decoding will error if the compressed stream has invalid data appended to it.

# Keyword Arguments

- `codec::BZ2Codec=BZ2Codec()`
"""
struct BZ2DecodeOptions <: DecodeOptions
    codec::BZ2Codec
end
function BZ2DecodeOptions(;
        codec::BZ2Codec=BZ2Codec(),
        kwargs...
    )
    BZ2DecodeOptions(codec)
end
is_thread_safe(::BZ2DecodeOptions) = true
can_concatenate(::BZ2DecodeOptions) = true

function try_find_decoded_size(::BZ2DecodeOptions, src::AbstractVector{UInt8})::Nothing
    nothing
end

function try_decode!(d::BZ2DecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    try_resize_decode!(d, dst, src, Int64(length(dst)))
end

function try_resize_decode!(d::BZ2DecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}, max_size::Int64; kwargs...)::MaybeSize
    dst_size::Int64 = length(dst)
    src_size::Int64 = length(src)
    src_left::Int64 = src_size
    dst_left::Int64 = dst_size
    check_contiguous(dst)
    check_contiguous(src)
    if isempty(src)
        throw(BZ2DecodingError(BZ_UNEXPECTED_EOF))
    end
    cconv_src = Base.cconvert(Ptr{UInt8}, src)
    # This outer loop is to decode a concatenation of multiple compressed streams.
    while true
        stream = BZStream()
        BZ2_bzDecompressInit(stream)
        try
            # This inner loop is needed because libbzip2 can work on at most 
            # 2^32 - 1 bytes at a time.
            while true
                # dst may get resized, so cconvert needs to be redone on each iteration.
                cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
                GC.@preserve cconv_src cconv_dst begin
                    src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
                    dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
                    start_avail_in = clamp(src_left, Cuint)
                    start_avail_out = clamp(dst_left, Cuint)
                    stream.avail_in = start_avail_in
                    stream.avail_out = start_avail_out
                    stream.next_in = src_p + (src_size - src_left)
                    stream.next_out = dst_p + (dst_size - dst_left)
                    ret = BZ2_bzDecompress(stream)
                    if ret == BZ_OK || ret == BZ_STREAM_END
                        @assert stream.avail_in ≤ start_avail_in
                        @assert stream.avail_out ≤ start_avail_out
                        dst_left -= start_avail_out - stream.avail_out
                        src_left -= start_avail_in - stream.avail_in
                        @assert src_left ∈ 0:src_size
                        @assert dst_left ∈ 0:dst_size
                    end
                    if ret == BZ_OK
                        if (
                                iszero(stream.avail_out) && !iszero(dst_left) ||
                                iszero(stream.avail_in) && !iszero(src_left) ||
                                !iszero(src_left) && !iszero(dst_left)
                            )
                            # there must be progress
                            @assert stream.avail_in < start_avail_in || stream.avail_out < start_avail_out
                        elseif iszero(dst_left) # needs more output
                            local next_size = grow_dst!(dst, max_size)
                            if isnothing(next_size)
                                return NOT_SIZE
                            end
                            dst_left += next_size - dst_size
                            dst_size = next_size
                            @assert dst_left > 0
                        else
                            @assert iszero(src_left) && !iszero(stream.avail_out)
                            throw(BZ2DecodingError(BZ_UNEXPECTED_EOF))
                        end
                    elseif ret == BZ_STREAM_END
                        if iszero(src_left)
                            # yay done return decompressed size
                            real_dst_size = dst_size - dst_left
                            @assert real_dst_size ∈ 0:length(dst)
                            return real_dst_size
                        else
                            # try and decompress next stream
                            # there must be progress
                            @assert stream.avail_in < start_avail_in || stream.avail_out < start_avail_out
                            break
                        end
                    elseif ret == BZ_PARAM_ERROR
                        error("BZ_PARAM_ERROR this should be unreachable")
                    elseif ret == BZ_DATA_ERROR || ret == BZ_DATA_ERROR_MAGIC
                        throw(BZ2DecodingError(ret))
                    elseif ret == BZ_MEM_ERROR
                        throw(OutOfMemoryError())
                    else
                        error("unknown bzip2 error code: $(ret)")
                    end
                end
            end
        finally
            BZ2_bzDecompressEnd(stream)
        end
    end
end

using Random: Random
using ChunkCodecCore: encode_bound, decoded_size_range, encode, decode
using ChunkCodecLibBzip2:
    ChunkCodecLibBzip2,
    BZ2Codec,
    BZ2EncodeOptions,
    BZ2DecodeOptions,
    BZ2DecodingError
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test
using Aqua: Aqua

Aqua.test_all(ChunkCodecLibBzip2; persistent_tasks = false)

Random.seed!(1234)
@testset "encode_bound" begin
    local a = last(decoded_size_range(BZ2EncodeOptions()))
    @test encode_bound(BZ2EncodeOptions(), a) == typemax(Int64) - 1
end
@testset "default" begin
    test_codec(BZ2Codec(), BZ2EncodeOptions(), BZ2DecodeOptions(); trials=50)
end
@testset "blockSize100k options" begin
    @test_throws ArgumentError BZ2EncodeOptions(; blockSize100k=0)
    @test_throws ArgumentError BZ2EncodeOptions(; blockSize100k=10)
    @test_throws ArgumentError BZ2EncodeOptions(; blockSize100k=-1)
    for i in 1:9
        test_codec(BZ2Codec(), BZ2EncodeOptions(; blockSize100k=i), BZ2DecodeOptions(); trials=5)
    end
end
@testset "unexpected eof" begin
    e = BZ2EncodeOptions()
    d = BZ2DecodeOptions()
    u = [0x00, 0x01, 0x02]
    c = encode(e, u)
    @test decode(d, c) == u
    for i in 1:length(c)
        @test_throws BZ2DecodingError(ChunkCodecLibBzip2.BZ_UNEXPECTED_EOF) decode(d, c[1:i-1])
    end
    @test_throws BZ2DecodingError decode(d, u)
    c[end] = 0x00
    @test_throws BZ2DecodingError decode(d, c)
    @test_throws BZ2DecodingError decode(d, [encode(e, u); c])
    @test_throws BZ2DecodingError decode(d, [encode(e, u); 0x00])
end
@testset "errors" begin
    @test sprint(Base.showerror, BZ2DecodingError(ChunkCodecLibBzip2.BZ_UNEXPECTED_EOF)) ==
        "BZ2DecodingError: BZ_UNEXPECTED_EOF: the compressed stream may be truncated"
    @test sprint(Base.showerror, BZ2DecodingError(ChunkCodecLibBzip2.BZ_DATA_ERROR)) ==
        "BZ2DecodingError: BZ_DATA_ERROR: a data integrity error is detected in the compressed stream"
    @test sprint(Base.showerror, BZ2DecodingError(ChunkCodecLibBzip2.BZ_DATA_ERROR_MAGIC)) ==
        "BZ2DecodingError: BZ_DATA_ERROR_MAGIC: the compressed stream doesn't begin with the right magic bytes"
    @test sprint(Base.showerror, BZ2DecodingError(-100)) ==
        "BZ2DecodingError: unknown bzip2 error code: -100"
end
@testset "encoding over 4GB" begin
    if Sys.WORD_SIZE == 64 && Sys.total_memory() > 15*Int64(2)^30
        n = Int64(2)^32 + 1
        c = encode(BZ2EncodeOptions(), zeros(UInt8, n))
        u = decode(BZ2Codec(), c; size_hint=n)
        all_zero = all(iszero, u)
        len_n = length(u) == n
        @test all_zero && len_n
    else
        @warn "skipping large memory tests"
    end
end

"""
    struct BZ2EncodeOptions <: EncodeOptions
    BZ2EncodeOptions(; kwargs...)

bzip2 compression using libbzip2: https://sourceware.org/bzip2/

# Keyword Arguments

-`codec::BZ2Codec=BZ2Codec()`
- `blockSize100k::Integer=9`: Specifies the block size to be used for compression.

  It should be a value between 1 and 9 inclusive, and the actual block size used
  is 100000 x this figure. The default 9 gives the best compression but takes most memory.
"""
struct BZ2EncodeOptions <: EncodeOptions
    codec::BZ2Codec
    blockSize100k::Int32
end
is_thread_safe(::BZ2EncodeOptions) = true

function BZ2EncodeOptions(;
        codec::BZ2Codec=BZ2Codec(),
        blockSize100k::Integer=9,
        kwargs...
    )
    check_in_range(1:9; blockSize100k)
    BZ2EncodeOptions(
        codec,
        blockSize100k,
    )
end

function decoded_size_range(::BZ2EncodeOptions)
    # prevent overflow of encode_bound
    Int64(0):Int64(1):Int64(0x7e07_e07e_07e0_7bb7)
end

# According to the docs https://sourceware.org/bzip2/manual/manual.html:
# "To guarantee that the compressed data will fit in its buffer,
# allocate an output buffer of size 1% larger than the uncompressed data,
# plus six hundred extra bytes."
function encode_bound(::BZ2EncodeOptions, src_size::Int64)::Int64
    clamp(widen(src_size) + widen(src_size>>6 + Int64(601)), Int64)
end

function try_encode!(e::BZ2EncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    if iszero(dst_size)
        return NOT_SIZE
    end
    stream = BZStream()
    BZ2_bzCompressInit(stream, e.blockSize100k)
    try
        # BZ2_bzCompress loop
        cconv_src = Base.cconvert(Ptr{UInt8}, src)
        cconv_dst = Base.cconvert(Ptr{UInt8}, dst)
        GC.@preserve cconv_src cconv_dst begin
            src_p = Base.unsafe_convert(Ptr{UInt8}, cconv_src)
            dst_p = Base.unsafe_convert(Ptr{UInt8}, cconv_dst)
            stream.next_in = src_p
            stream.next_out = dst_p
            src_left::Int64 = src_size
            dst_left::Int64 = dst_size
            while true
                start_avail_in = clamp(src_left, Cuint)
                start_avail_out = clamp(dst_left, Cuint)
                stream.avail_in = start_avail_in
                stream.avail_out = start_avail_out
                @assert !iszero(stream.avail_out)
                action = if stream.avail_in == src_left
                    BZ_FINISH
                else
                    BZ_RUN
                end
                ret = BZ2_bzCompress(stream, action)
                @assert ret != BZ_PARAM_ERROR # state not clobbered
                @assert stream.avail_in ≤ start_avail_in
                @assert stream.avail_out ≤ start_avail_out
                # there must be progress
                @assert stream.avail_in < start_avail_in || stream.avail_out < start_avail_out
                src_left -= start_avail_in - stream.avail_in
                dst_left -= start_avail_out - stream.avail_out
                @assert src_left ∈ 0:src_size
                @assert dst_left ∈ 0:dst_size
                @assert stream.next_in == src_p + (src_size - src_left)
                @assert stream.next_out == dst_p + (dst_size - dst_left)
                if ret == BZ_STREAM_END
                    # yay done just return compressed size
                    @assert dst_left ∈ 0:dst_size
                    @assert iszero(src_left)
                    return dst_size - dst_left
                end
                if iszero(dst_left)
                    # no more space, but not BZ_STREAM_END
                    return NOT_SIZE
                end
                if action == BZ_RUN
                    @assert ret == BZ_RUN_OK
                else
                    @assert ret == BZ_FINISH_OK
                end
            end
        end
    finally
        BZ2_bzCompressEnd(stream)
    end
end

module ChunkCodecLibBzip2

using Bzip2_jll: libbzip2

using ChunkCodecCore:
    Codec,
    EncodeOptions,
    DecodeOptions,
    check_in_range,
    check_contiguous,
    grow_dst!,
    DecodingError,
    MaybeSize,
    NOT_SIZE
import ChunkCodecCore:
    decode_options,
    can_concatenate,
    try_decode!,
    try_resize_decode!,
    try_encode!,
    encode_bound,
    is_thread_safe,
    try_find_decoded_size,
    decoded_size_range

export BZ2Codec,
    BZ2EncodeOptions,
    BZ2DecodeOptions,
    BZ2DecodingError

# reexport ChunkCodecCore
using ChunkCodecCore: ChunkCodecCore, encode, decode
export ChunkCodecCore, encode, decode


include("libbzip2.jl")

"""
    struct BZ2Codec <: Codec
    BZ2Codec()

bzip2 compression using libbzip2: https://sourceware.org/bzip2/

Like the command line tool `bunzip2`, decoding accepts concatenated compressed data and returns the decompressed data concatenated.
Unlike `bunzip2`, decoding will error if the compressed stream has invalid data appended to it.

See also [`BZ2EncodeOptions`](@ref) and [`BZ2DecodeOptions`](@ref)
"""
struct BZ2Codec <: Codec
end
decode_options(::BZ2Codec) = BZ2DecodeOptions()

include("encode.jl")
include("decode.jl")

end # module ChunkCodecLibBzip2
